CREATE GENERATOR gen_ARTICLE_id;
SET GENERATOR gen_ARTICLE_id TO 0;
CREATE GENERATOR gen_CARACTERISTIQUE_id;
SET GENERATOR gen_CARACTERISTIQUE_id TO 0;
CREATE GENERATOR gen_GAMME_id;
SET GENERATOR gen_GAMME_id TO 0;
CREATE GENERATOR gen_TYPE_PRODUIT_id;
SET GENERATOR gen_TYPE_PRODUIT_id TO 0;

/************** Création des TABLES **************/

CREATE TABLE ARTICLE (
	ARTI_Clep int,
	ARTI_Libcom varchar (120)   NOT NULL,
	ARTI__CARA int,
	ARTI__TYPR int,
	ARTI__GAMM int,
	PRIMARY KEY  ( ARTI_Clep )
);

CREATE TABLE CARACTERISTIQUE (
	CARA_Clep int   NOT NULL,
	CARA_Libelle varchar (150) ,
	PRIMARY KEY  ( CARA_Clep ) 
);

CREATE TABLE GAMME (
	GAMM_Clep int   NOT NULL,
	GAMM_Libelle varchar (100) ,
	PRIMARY KEY  ( GAMM_Clep ) 
);

CREATE TABLE GAMME_TYPR (
	GATY__GAMM int   NOT NULL,
	GATY__TYPR int   NOT NULL,
	PRIMARY KEY  ( GATY__GAMM, GATY__TYPR )
);
CREATE TABLE TYPE_PRODUIT (
	TYPR_Clep int   NOT NULL,
	TYPR_Libelle varchar (120)  ,
	PRIMARY KEY  ( TYPR_Clep )
);

CREATE TABLE TYPE_PRODUIT_CARA (
	TYPC__TYPR int   NOT NULL,
	TYPC__CARA int   NOT NULL,
	PRIMARY KEY  ( TYPC__TYPR, TYPC__CARA )
);



/************** Ajout des clés étrangères **************/

ALTER TABLE ARTICLE ADD FOREIGN KEY 
	(
		ARTI__CARA
	) REFERENCES CARACTERISTIQUE (
		CARA_Clep
	);
ALTER TABLE ARTICLE ADD FOREIGN KEY 
	(
		ARTI__GAMM
	) REFERENCES GAMME (
		GAMM_Clep
	);
ALTER TABLE ARTICLE ADD FOREIGN KEY 
	(
		ARTI__TYPR
	) REFERENCES TYPE_PRODUIT (
		TYPR_Clep
	);

ALTER TABLE GAMME_TYPR ADD FOREIGN KEY 
	(
		GATY__GAMM
	) REFERENCES GAMME (
		GAMM_Clep
	) ON DELETE CASCADE  ON UPDATE CASCADE;
ALTER TABLE GAMME_TYPR ADD  FOREIGN KEY 
	(
		GATY__TYPR
	) REFERENCES TYPE_PRODUIT (
		TYPR_Clep
	) ON DELETE CASCADE  ON UPDATE CASCADE;

ALTER TABLE TYPE_PRODUIT_CARA ADD  FOREIGN KEY 
	(
		TYPC__CARA
	) REFERENCES CARACTERISTIQUE (
		CARA_Clep
	) ON DELETE CASCADE  ON UPDATE CASCADE;
ALTER TABLE TYPE_PRODUIT_CARA ADD  FOREIGN KEY 
	(
		TYPC__TYPR
	) REFERENCES TYPE_PRODUIT (
		TYPR_Clep
	) ON DELETE CASCADE  ON UPDATE CASCADE;

COMMIT;
/************** Création des Triggers **************/
/* Les triggers liés aux indicateurs des lots */

set term ! ;
CREATE TRIGGER GAMME_GEN FOR GAMME
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
if (NEW.GAMM_CLEP is NULL ) then NEW.GAMM_CLEP =GEN_ID(GEN_GAMME_ID, 1);
END!
CREATE TRIGGER TYPE_PRODUIT_GEN FOR TYPE_PRODUIT
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
if (NEW.TYPR_CLEP is NULL ) then NEW.TYPR_CLEP =GEN_ID(GEN_TYPE_PRODUIT_ID, 1);
END!
CREATE TRIGGER ARTICLE_GEN FOR ARTICLE
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
if (NEW.ARTI_CLEP is NULL ) then NEW.ARTI_CLEP =GEN_ID(GEN_ARTICLE_ID, 1);
END!
CREATE TRIGGER CARACTERISTIQUE_GEN FOR CARACTERISTIQUE
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
if (NEW.CARA_CLEP is NULL ) then NEW.CARA_CLEP =GEN_ID(GEN_CARACTERISTIQUE_ID, 1);
END!

set term ; !
COMMIT;

